<?php

require 'classes/Quest.php';
require 'classes/AddReward.php';

class EquipController{

    protected function getMysql($account_id)
    {
        $mysql_conf = getMysqlConfig(crc32($account_id));
        $conn = new phpcommon\Mysql(array(
            'host' => $mysql_conf['host'],
            'port' => $mysql_conf['port'],
            'user' => $mysql_conf['user'],
            'passwd' => $mysql_conf['passwd'],
            'dbname' => 'gamedb2004_' . $mysql_conf['instance_id']
        ));
        return $conn;
    }

    protected function getItem($item_id)
    {
        $g_conf_item_cluster = require('../res/item@item.php');
        $item_conf = getItemConfig($g_conf_item_cluster, $item_id);
        $it = array(
            'id' => $item_conf['id'],
            'diamond' => $item_conf['diamond'],
            'dprice' => $item_conf['dprice'],
            'type' => $item_conf['fuction'],
            'diamond_hour' => $item_conf['diamond_hour']
        );
        return $it;
    }

    protected function getParameter($para_id)
    {
        $g_conf_para_cluster = require('../res/parameter@parameter.php');
        $para_conf = getParameterConfig($g_conf_para_cluster, $para_id);
        $p = array(
            'id' => $para_conf['id'],
            'param_name' => $para_conf['param_name'],
            'param_value' => $para_conf['param_value'],
        );
        return $p;
    }

    protected function getEquip($equip_id)
    {
        $g_conf_equip_cluster = require('../res/equip@equip.php');
        $equip_conf = getEquipConfig($g_conf_equip_cluster, $equip_id);
        $e = array(
            'id' => $equip_conf['id'],
            'upgrade_priority' => $equip_conf['upgrade_priority'],
            'equip_upgrade' => $equip_conf['equip_upgrade'],
            'level_gold_cost' => $equip_conf['level_gold_cost'],
            'max_level' => $equip_conf['max_level'],
            'equip_upgradematerial' => $equip_conf['equip_upgradematerial'],
            'equip_upgradetime' => $equip_conf['equip_upgradetime'],
            'diamond_cost' => $equip_conf['diamond_cost'],
            'reduce_time' => $equip_conf['reduce_time'],
            'diamond_time' => $equip_conf['diamond_time'],
         );
        return $e;
    }

    protected function getExplode($string)
    {
        $delim = "|";
        $drop_multiply = explode($delim, $string);
        $delim1 = ":";
        $arr = array();
        for ($i = 0; $i < count($drop_multiply); $i++) {
            $mul = explode($delim1, $drop_multiply[$i]);
            array_push($arr, $mul);
        }
        return $arr;
    }

    public function getEquipInfo()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $equip_list = array();
        $time_flag = 0;
        $row = $conn->execQueryOne('SELECT * FROM equip WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id
                                   ));
        if (!$row) {
            $id = 0;
            $g_conf_lot_cluster = require('../res/equip@equip.php');
            for ($i = 0; $i < count($g_conf_lot_cluster); $i++) {
                $e = $this->getEquip(12100 + $i);
                if (!$e) {
                    continue;
                }
                if ($e['upgrade_priority'] == 1) {
                    $id = $e['id'];
                    break;
                }
            }
            $ret = $conn->execScript('INSERT INTO equip(accountid, id, lv, active_time, sub_time, create_time, modify_time, using_id) ' .
                                     ' VALUES(:account_id, :id, 0, :active_time, :sub_time, :create_time, :modify_time, :using_id) ' .
                                     ' ON DUPLICATE KEY UPDATE accountid=:account_id, id=:id, lv=0, active_time=:active_time, sub_time=:sub_time, modify_time=:modify_time, using_id=:using_id;',
                                     array(
                                         ':account_id' => $account_id,
                                         ':id' => $id,
                                         ':active_time' => 0,
                                         ':create_time' => time(),
                                         ':modify_time' => time(),
                                         ':sub_time' => 0,
                                         ':using_id' => $id,
                                     ));
            if(!$ret){
                die();
                return;
            }
            $ret = $conn->execScript('INSERT INTO bag(accountid, id, color_id, status, num, active_time, create_time, modify_time) ' .
                                     ' VALUES(:account_id, :id, 0, :status, 1, :active_time, :create_time, :modify_time) ' .
                                     ' ON DUPLICATE KEY UPDATE accountid=:account_id, id=:id, color_id=0, status=:status, num=1, active_time=:active_time, modify_time=:modify_time;',
                                     array(
                                         ':account_id' => $account_id,
                                         ':id' => 18004,
                                         ':active_time' => 0,
                                         ':status' => 0,
                                         ':create_time' => time(),
                                         ':modify_time' => time()
                                     ));
            array_push($equip_list, array(
                'id' => $id,
                'lv' => 0,
                'active_time' => 0,
                'using_id' => $id,
            ));
        } else {
            $time = $row['active_time'] + $row['sub_time'];
            $using_id = $row['using_id'];
            if (time() >= $row['active_time'] + $row['sub_time'] && $row['sub_time'] != 0) {
                $ret1 = $conn->execScript('UPDATE equip SET active_time=0, sub_time=0, using_id=:using_id, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':modify_time' => time(),
                                             ':using_id' => $row['id'],
                                         ));
                if (!$ret1) {
                    die();
                    return;
                }
                $time = 0;
                $time_flag = 1;
                $using_id = $row['id'];
            }
            array_push($equip_list, array(
                'id' => $row['id'],
                'lv' => $row['lv'],
                'active_time' => $time,
                'using_id' => $using_id,
            ));
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'equip_list' => $equip_list,
            'time_flag' => $time_flag,
        ));
    }

    public function updateEquip()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        $equip_list = array();
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $row = $conn->execQueryOne('SELECT * FROM equip WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id
                                   ));
        $rowUser = $conn->execQueryOne('SELECT coin_num, diamond_num FROM user WHERE accountid=:account_id;',
                                       array(
                                           ':account_id' => $account_id
                                       ));
        if (!$row || !$rowUser) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $e = $this->getEquip($row['id']);
        if (!$e) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个装备');
            return;
        }
        $flag = 0;
        $id = $row['id'];
        if ($row['lv'] < $e['max_level']) {
            //金币升级
            $coin_array = $this->getExplode($e['level_gold_cost']);
            $coin_num = $coin_array[$row['lv']][0];
            if ($rowUser['coin_num'] < $coin_num) {
                phpcommon\sendError(ERR_USER_BASE + 3, '金币不足');
                return;
            }
            $retuser = $conn->execScript('UPDATE user SET coin_num=:coin_num, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':coin_num' => $rowUser['coin_num'] - $coin_num,
                                             ':modify_time' => time()
                                         ));
            $ret = $conn->execScript('UPDATE equip SET lv=:lv, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':lv' => $row['lv'] + 1,
                                         ':modify_time' => time()
                                     ));
            if (!$ret || !$retuser) {
                die();
                return;
            }
        } else {
            //装备进阶
            $rowBag = $conn->execQuery('SELECT * FROM bag WHERE accountid=:account_id AND id>18000 AND id<19000;',
                                       array(
                                           ':account_id' => $account_id
                                       ));
            $max_p = $e['upgrade_priority'];
            $g_conf_lot_cluster = require('../res/equip@equip.php');
            for ($i = 0; $i < count($g_conf_lot_cluster); $i++) {
                $ec = $this->getEquip(12100 + $i);
                if (!$ec) {
                    continue;
                }
                if ($ec['upgrade_priority'] == $max_p + 1) {
                    $id = $ec['id'];
                    break;
                }
            }
            if ($id == $row['id']) {
                phpcommon\sendError(ERR_USER_BASE + 4, '装备已达满级');
                return;
            }
            $mar_array = $this->getExplode($e['equip_upgradematerial']);
            $mflag = 0;
            for ($m = 0; $m < count($mar_array); $m++) {
                foreach ($rowBag as $rb) {
                    if ($rb['id'] == $mar_array[$m][0]) {
                        if ($rb['num'] >= $mar_array[$m][1]) {
                            $mflag++;
                        }
                    }
                }
            }
            if ($mflag < count($mar_array)) {
                phpcommon\sendError(ERR_USER_BASE + 5, '材料不足');
                return;
            }
            //扣除材料
            for ($m = 0; $m < count($mar_array); $m++) {
                foreach ($rowBag as $rb) {
                    if ($rb['id'] != $mar_array[$m][0]) {
                        continue;
                    }
                    $retbag = $conn->execScript('UPDATE bag SET num=:num, modify_time=:modify_time ' .
                                                ' WHERE accountid=:accountid AND id=:id;',
                                                array(
                                                    ':accountid' => $account_id,
                                                    ':num' => $rb['num'] - $mar_array[$m][1],
                                                    ':id' => $rb['id'],
                                                    ':modify_time' => time()
                                                ));
                    if (!$retbag) {
                        die();
                        return;
                    }
                    break;
                }
            }
            $active_time = time();
            $sub_time = $e['equip_upgradetime'];
            $using_id = $row['using_id'];
            if ($e['equip_upgradetime'] == 0) {
                $active_time = 0;
                $flag = 1;
                $using_id = $id;
            }
            $retEquip = $conn->execScript('UPDATE equip SET id=:id, lv=0, active_time=:active_time, using_id=:using_id, sub_time=:sub_time, modify_time=:modify_time ' .
                                          ' WHERE accountid=:accountid;',
                                          array(
                                              ':accountid' => $account_id,
                                              ':id' => $id,
                                              ':modify_time' => time(),
                                              ':active_time' => $active_time,
                                              ':sub_time' => $sub_time,
                                              ':using_id' => $using_id,
                                          ));
            if (!$retEquip) {
                die();
                return;
            }
        }
        $addreward = new classes\AddReward();
        $coin_num = $addreward->getCoinNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'coin_nums' => $coin_num,
            'flag' => $flag,
            'id' => $id,
        ));
    }

    public function  speedUpTime()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $type = $_REQUEST['type'];
        $row = $conn->execQueryOne('SELECT * FROM equip WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $e1 = $this->getEquip($row['id']);
        $last_id = $e1['upgrade_priority'];
        $id = 0;
        $g_conf_lot_cluster = require('../res/equip@equip.php');
        for ($i = 0; $i < count($g_conf_lot_cluster); $i++) {
            $ec = $this->getEquip(12100 + $i);
            if (!$ec || empty($ec['upgrade_priority'])) {
                continue;
            }
            if ($ec['upgrade_priority'] == (int)$last_id - 1) {
                $id = $ec['id'];
                break;
            }
        }
        $e = $this->getEquip($id);
        if (!$e) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个装备');
            return;
        }
        $flag = 0;
        //error_log($e['reduce_time']);
        $sub_time = $row['sub_time'] - floor($row['sub_time'] * $e['reduce_time'] * 0.01);
        if ($type == 1) {
            $rowUser = $conn->execQueryOne('SELECT diamond_num FROM user WHERE accountid=:account_id;',
                                           array(
                                               ':account_id' => $account_id
                                           ));
            if (!$rowUser) {
                phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
                return;
            }
            if ($rowUser['diamond_num'] < $e['diamond_cost']) {
                phpcommon\sendError(ERR_USER_BASE + 3, '钻石不足');
                return;
            }
            $sub_time = $row['sub_time'] - floor($row['sub_time'] * $e['diamond_time'] * 0.01);
            $retUser = $conn->execScript('UPDATE user SET diamond_num=:diamond_num, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':diamond_num' => $rowUser['diamond_num'] - $e['diamond_cost'],
                                             ':modify_time' => time()
                                         ));
            if (!$retUser) {
                die();
                return;
            }
        }
        $active_time = $row['active_time'];
        $using_id = $row['using_id'];
        if ($active_time + $sub_time <= time()) {
            $active_time = 0;
        }
        if ($sub_time == 0) {
            $flag = 1;
            $using_id = $row['id'];
        }
        $retEquip = $conn->execScript('UPDATE equip SET active_time=:active_time, using_id=:using_id, sub_time=:sub_time, modify_time=:modify_time ' .
                                      ' WHERE accountid=:accountid;',
                                      array(
                                          ':accountid' => $account_id,
                                          ':active_time' => $active_time,
                                          ':sub_time' => $sub_time,
                                          ':modify_time' => time(),
                                          ':using_id' => $using_id,
                                      ));
        if (!$retEquip) {
            die();
            return;
        }
        $addreward = new classes\AddReward();
        $num = $addreward->getDiamondNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'diamond_nums' => $num,
            'active_time' => $active_time,
            'flag' => $flag,
            'id' => $row['id'],
        ));
    }

    public function exchangeEquip()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $equip_id = $_REQUEST['id'];
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $row = $conn->execQueryOne('SELECT id, using_id FROM equip WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        if ($equip_id > $row['id']) {
            phpcommon\sendError(ERR_USER_BASE + 3, '武器未获得');
            return;
        }
        $ret = $conn->execScript('UPDATE equip SET using_id=:using_id, modify_time=:modify_time ' .
                                 ' WHERE accountid=:accountid;',
                                 array(
                                     ':accountid' => $account_id,
                                     ':using_id' => $equip_id,
                                     ':modify_time' => time(),
                                 ));
        if (!$ret) {
            die();
            return;
        }

        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'using_id' => $equip_id,
        ));
    }
}
?>
